package web.taglib;

import javax.el.*;
import javax.servlet.jsp.*;
import javax.servlet.jsp.tagext.*;
import java.util.List;
import java.util.Iterator;
import java.util.Enumeration;
import java.io.IOException;

public class TestTag extends SimpleTagSupport {

    private static final String JSP2_1 = "jsp21";
    private static final String JSP2_0 = "jsp20";
    private Object val1, val2;
    private boolean debug;
    private String jspv;
    

    public void setVal1(Object val1) {
        this.val1 = val1;
    }

    public void setVal2(Object val2) {
        this.val2 = val2;
    }

    public void setJspv(String jspv) {
        this.jspv = jspv;
    }

    public void setDebug(boolean debug) {
        this.debug = debug;
    }


    public void doTag() throws JspException, IOException {

        ELContext elContext = getJspContext().getELContext();
        JspWriter out = getJspContext().getOut();
        boolean pass = false;

        try {
            if (debug) out.println("jspv = " + jspv);

            if (val1 instanceof ValueExpression) {
                ValueExpression vexp1 = (ValueExpression) val1;
                if (debug)
                     out.println("vexp1 = " + vexp1.getValue(elContext) );
            }  else {
                if (debug)
 	             out.println("val1 = " + val1);
            }

            if (val2 instanceof ValueExpression) {
                ValueExpression vexp2 = (ValueExpression) val2;

                if (debug){
                    out.println("vexp2 = " + vexp2.getValue(elContext));
		}

                Object value = (Object)  vexp2.getValue(elContext);

                if (jspv.equals(JSP2_0) && value.toString().startsWith("#") ){
                   pass = true;

                }
              
                if (jspv.equals(JSP2_1) &&  (((List) value) instanceof List) ) {
                    pass = true;
		} 
              
            }  else {
                int pindex = ((String) val2).indexOf("#");
                if (debug) {
	            out.println("val2 = " + val2);
                    out.println("pindex = " + pindex);
		}
                if (jspv.equals(JSP2_1) && (pindex == 0)){
                    pass = true;
		} 
            }

            if (pass)
               out.println("Test PASSED");
            else
               out.println("Test FAILED");                
        } catch (Throwable t) {
            System.out.println("TestTag:failed\n" + t);
        }
    }

}
